!==================================================================================
!   Win Api
!  , ., 2022 .
!==================================================================================

                     MEMBER

   INCLUDE('FsWinApiExt.INC')
   INCLUDE('WINEQU.INC')

   MAP
     INCLUDE('BUILTINS.CLW'),ONCE   ! RTL
     INCLUDE('CWUTIL.INC'),ONCE
 
     MODULE('WINAPI')
       fsWAE_FreeLibrary(ULONG hModule),BYTE,PASCAL,RAW,NAME('FreeLibrary'),PROC
       fsWAE_GetProcAddress(ULONG hModule,*CSTRING pszProcName),LONG,PASCAL,RAW,NAME('GetProcAddress')
       fsWAE_LoadLibrary(*CSTRING pszModuleFileName),ULONG,PASCAL,RAW,NAME('LoadLibraryA')
       fsWAE_MultiByteToWideChar(Unsigned Codepage,Ulong dwFlags,ULong LpMultuByteStr, Long cbMultiByte, ULong LpWideCharStr,Long cchWideChar),RAW,PROC,Ulong,PASCAL,NAME('MultiByteToWideChar')
       fsWAE_WideCharToMultiByte(Unsigned Codepage,Ulong dwFlags,ULong LpWideCharStr,Long cchWideChar, ULong lpMultuByteStr, Long cbMultiByte, Ulong LpDefalutChar,Ulong lpUsedDefalutChar),Raw,PROC,Ulong,Pascal,NAME('WideCharToMultiByte')
     END

     MODULE('kernel32.dll')
       fsWAE_GetDiskFreeSpace(<*CSTRING lpDirectoryName>,LONG lpFreeBytesAvailableToCaller=0,LONG lpTotalNumberOfBytes=0,LONG lpTotalNumberOfFreeBytes=0),BOOL,PASCAL,RAW,DLL(_GetDiskFreeSpaceExA_),name('GetDiskFreeSpaceExA')  
     END

   END

   INCLUDE('FsWinApiExt.equ')

!===================================================================================
!  
!
FsWinApiExt.Init PROCEDURE  
loc:NameDLL  CSTRING('kernel32.dll')
      CODE

   if SELF.Active=1
      return
   end

   SELF.HandleDLL = fsWAE_LoadLibrary(loc:NameDLL)
   if SELF.HandleDLL=0
      return
   end 
            
   SELF.Active=1            
   SELF.LoadLib
   if SELF.Active=0
      if fsWAE_FreeLibrary(SELF.HandleDLL)
      end
      SELF.Active=0
      return
   end

 !===================================================================================
!  
!
FsWinApiExt.LoadLib PROCEDURE
      CODE

   ! 
   loop
      _GetDiskFreeSpaceExA_ = fsWAE_GetProcAddress(SELF.HandleDLL, cstr_GetDiskFreeSpaceExA)
      if _GetDiskFreeSpaceExA_ =0
         SELF.Active=0
         break
      end
      
      break
   end     

!===================================================================================
!  
!
FsWinApiExt.Kill PROCEDURE
      CODE
      
   if SELF.Active=1  
      if fsWAE_FreeLibrary(SELF.HandleDLL)
      end        
   end     

   SELF.Active=0
  
!===================================================================================
!
!  
!
FsWinApiExt.Destruct PROCEDURE
   CODE
      if SELF.Active=1
         SELF.Kill
      end
        
!===================================================================================
!     
!
FsWinApiExt.GetDiskFreeSpace FUNCTION (STRING pDir)
loc:szDirectory                      CSTRING(32)
loc:u64_FreeBytesAvailableToCaller   LIKE(fsWAE_INT64)
loc:u64_TotalNumberOfBytes           LIKE(fsWAE_INT64)
loc:u64_TotalNumberOfFreeBytes       LIKE(fsWAE_INT64)            
loc:freeBytes                        DECIMAL(31)
loc:zn                               STRING(32)
      CODE   
      
       loc:freeBytes=0
       loc:szDirectory = clip(pDir)        
       if fsWAE_GetDiskFreeSpace(loc:szDirectory,Address(loc:u64_FreeBytesAvailableToCaller),Address(loc:u64_TotalNumberOfBytes),Address(loc:u64_TotalNumberOfFreeBytes)) = TRUE
          loc:freeBytes = (loc:u64_FreeBytesAvailableToCaller.Hi * 4294967295) + loc:u64_FreeBytesAvailableToCaller.Lo
       end
      
       loc:zn=loc:freeBytes
       return(loc:zn)
      
      